'use strict';

goog.provide('Blockly.JavaScript.texts');
goog.require('Blockly.JavaScript');


// ***********************************************************************************
// ----------------------------------- auxiliary -------------------------------------
// ***********************************************************************************

function generatePutCode(name, xSize, zSize, brick, block) {
    
    var x    = block.getFieldValue('xVal');
    var z    = block.getFieldValue('zVal');
    var sym  = Blockly.JavaScript.valueToCode(block, 'semi_or_epsilon', Blockly.JavaScript.ORDER_ADDITION) || '1';     
    var code = 'put(' + xSize + ',' + zSize + ',' + x + ',' + z + ',' + brick + ');\n';    
  
    processBegin('call', name + '(' + x + ',' + z + ')',sym);         
    processEnd  (CALL  , name + '(' + x + ',' + z + ')' + sym);
    
    wellFormedInt(x);
    wellFormedInt(z);
    
    return code;    
}


// ***********************************************************************************
// ----------------------------------- EMPTY -----------------------------------------
// ***********************************************************************************

Blockly.JavaScript['put2D_1x1_EMPTY'] = function(block) {
    return generatePutCode('put2D_1x1_EMPTY',1,1,emptyGen,block);  
};

// -----------------------------------------------------------------------------------
Blockly.JavaScript['put2D_2x1_EMPTY'] = function(block) {
    return generatePutCode('put2D_2x1_EMPTY',2,1,emptyGen,block);  
};

// -----------------------------------------------------------------------------------
Blockly.JavaScript['put2D_1x2_EMPTY'] = function(block) {
    return generatePutCode('put2D_1x2_EMPTY',1,2,emptyGen,block);  
};

// -----------------------------------------------------------------------------------
Blockly.JavaScript['put2D_2x2_EMPTY'] = function(block) {
    return generatePutCode('put2D_2x2_EMPTY',2,2,emptyGen,block);  
};

// -----------------------------------------------------------------------------------
Blockly.JavaScript['put2D_3x2_EMPTY'] = function(block) {
    return generatePutCode('put2D_3x2_EMPTY',3,2,emptyGen,block);  
};

// -----------------------------------------------------------------------------------
Blockly.JavaScript['put2D_2x3_EMPTY'] = function(block) {
    return generatePutCode('put2D_2x3_EMPTY',2,3,emptyGen,block);  
};

// -----------------------------------------------------------------------------------
Blockly.JavaScript['put2D_4x2_EMPTY'] = function(block) {
    return generatePutCode('put2D_4x2_EMPTY',4,2,emptyGen,block);  
};

// -----------------------------------------------------------------------------------
Blockly.JavaScript['put2D_2x4_EMPTY'] = function(block) {
    return generatePutCode('put2D_2x4_EMPTY',2,4,emptyGen,block);  
};


// ***********************************************************************************
// ----------------------------------- YELLOW ----------------------------------------
// ***********************************************************************************

Blockly.JavaScript['put2D_1x1_YELLOW'] = function(block) {
    return generatePutCode('put2D_1x1_YELLOW',1,1,yellowGen,block);  
};

// -----------------------------------------------------------------------------------
Blockly.JavaScript['put2D_2x1_YELLOW'] = function(block) {
    return generatePutCode('put2D_2x1_YELLOW',2,1,yellowGen,block);  
};

// -----------------------------------------------------------------------------------
Blockly.JavaScript['put2D_1x2_YELLOW'] = function(block) {
    return generatePutCode('put2D_1x2_YELLOW',1,2,yellowGen,block);  
};

// -----------------------------------------------------------------------------------
Blockly.JavaScript['put2D_2x2_YELLOW'] = function(block) {
    return generatePutCode('put2D_2x2_YELLOW',2,2,yellowGen,block);  
};

// -----------------------------------------------------------------------------------
Blockly.JavaScript['put2D_3x2_YELLOW'] = function(block) {
    return generatePutCode('put2D_3x2_YELLOW',3,2,yellowGen,block);  
};

// -----------------------------------------------------------------------------------
Blockly.JavaScript['put2D_2x3_YELLOW'] = function(block) {
    return generatePutCode('put2D_2x3_YELLOW',2,3,yellowGen,block);  
};

// -----------------------------------------------------------------------------------
Blockly.JavaScript['put2D_4x2_YELLOW'] = function(block) {
    return generatePutCode('put2D_4x2_YELLOW',4,2,yellowGen,block);  
};

// -----------------------------------------------------------------------------------
Blockly.JavaScript['put2D_2x4_YELLOW'] = function(block) {
    return generatePutCode('put2D_2x4_YELLOW',2,4,yellowGen,block);  
};


// ***********************************************************************************
// ----------------------------------- BLUE ------------------------------------------
// ***********************************************************************************
Blockly.JavaScript['put2D_1x1_BLUE'] = function(block) {
    return generatePutCode('put2D_1x1_BLUE',1,1,blueGen,block);  
};

// -----------------------------------------------------------------------------------
Blockly.JavaScript['put2D_2x1_BLUE'] = function(block) {
    return generatePutCode('put2D_2x1_BLUE',2,1,blueGen,block);  
};

// -----------------------------------------------------------------------------------
Blockly.JavaScript['put2D_1x2_BLUE'] = function(block) {
    return generatePutCode('put2D_1x2_BLUE',1,2,blueGen,block);  
};

// -----------------------------------------------------------------------------------
Blockly.JavaScript['put2D_2x2_BLUE'] = function(block) {
    return generatePutCode('put2D_2x2_BLUE',2,2,blueGen,block);  
};

// -----------------------------------------------------------------------------------
Blockly.JavaScript['put2D_3x2_BLUE'] = function(block) {
    return generatePutCode('put2D_3x2_BLUE',3,2,blueGen,block);  
};

// -----------------------------------------------------------------------------------
Blockly.JavaScript['put2D_2x3_BLUE'] = function(block) {
    return generatePutCode('put2D_2x3_BLUE',2,3,blueGen,block);  
};

// -----------------------------------------------------------------------------------
Blockly.JavaScript['put2D_4x2_BLUE'] = function(block) {
    return generatePutCode('put2D_4x2_BLUE',4,2,blueGen,block);  
};

// -----------------------------------------------------------------------------------
Blockly.JavaScript['put2D_2x4_BLUE'] = function(block) {
    return generatePutCode('put2D_2x4_BLUE',2,4,blueGen,block);  
};

// ***********************************************************************************
// ----------------------------------- RED -------------------------------------------
// ***********************************************************************************

Blockly.JavaScript['put2D_1x1_RED'] = function(block) {
    return generatePutCode('put2D_1x1_RED',1,1,redGen,block);  
};

// -----------------------------------------------------------------------------------
Blockly.JavaScript['put2D_2x1_RED'] = function(block) {
    return generatePutCode('put2D_2x1_RED',2,1,redGen,block);  
};

// -----------------------------------------------------------------------------------
Blockly.JavaScript['put2D_1x2_RED'] = function(block) {
    return generatePutCode('put2D_1x2_RED',1,2,redGen,block);  
};

// -----------------------------------------------------------------------------------
Blockly.JavaScript['put2D_2x2_RED'] = function(block) {
    return generatePutCode('put2D_2x2_RED',2,2,redGen,block);  
};

// -----------------------------------------------------------------------------------
Blockly.JavaScript['put2D_3x2_RED'] = function(block) {
    return generatePutCode('put2D_3x2_RED',3,2,redGen,block);  
};

// -----------------------------------------------------------------------------------
Blockly.JavaScript['put2D_2x3_RED'] = function(block) {
    return generatePutCode('put2D_2x3_RED',2,3,redGen,block);  
};

// -----------------------------------------------------------------------------------
Blockly.JavaScript['put2D_4x2_RED'] = function(block) {
    return generatePutCode('put2D_4x2_RED',4,2,redGen,block);  
};

// -----------------------------------------------------------------------------------
Blockly.JavaScript['put2D_2x4_RED'] = function(block) {
    return generatePutCode('put2D_2x4_RED',2,4,redGen,block);  
};

// ***********************************************************************************
// ----------------------------------- GREEN -----------------------------------------
// ***********************************************************************************

Blockly.JavaScript['put2D_1x1_GREEN'] = function(block) {
    return generatePutCode('put2D_1x1_GREEN',1,1,greenGen,block);  
};

// -----------------------------------------------------------------------------------
Blockly.JavaScript['put2D_2x1_GREEN'] = function(block) {
    return generatePutCode('put2D_2x1_GREEN',2,1,greenGen,block);  
};

// -----------------------------------------------------------------------------------
Blockly.JavaScript['put2D_1x2_GREEN'] = function(block) {
    return generatePutCode('put2D_1x2_GREEN',1,2,greenGen,block);  
};

// -----------------------------------------------------------------------------------
Blockly.JavaScript['put2D_2x2_GREEN'] = function(block) {
    return generatePutCode('put2D_2x2_GREEN',2,2,greenGen,block);  
};

// -----------------------------------------------------------------------------------
Blockly.JavaScript['put2D_3x2_GREEN'] = function(block) {
    return generatePutCode('put2D_3x2_GREEN',3,2,greenGen,block);  
};

// -----------------------------------------------------------------------------------
Blockly.JavaScript['put2D_2x3_GREEN'] = function(block) {
    return generatePutCode('put2D_2x3_GREEN',2,3,greenGen,block);  
};

// -----------------------------------------------------------------------------------
Blockly.JavaScript['put2D_4x2_GREEN'] = function(block) {
    return generatePutCode('put2D_4x2_GREEN',4,2,greenGen,block);  
};

// -----------------------------------------------------------------------------------
Blockly.JavaScript['put2D_2x4_GREEN'] = function(block) {
    return generatePutCode('put2D_2x4_GREEN',2,4,greenGen,block);  
};
    
// ***********************************************************************************
// ----------------------------------- BLACK -----------------------------------------
// ***********************************************************************************
Blockly.JavaScript['put2D_1x1_BLACK'] = function(block) {
    return generatePutCode('put2D_1x1_BLACK',1,1,blackGen,block);  
};

// -----------------------------------------------------------------------------------
Blockly.JavaScript['put2D_2x1_BLACK'] = function(block) {
    return generatePutCode('put2D_2x1_BLACK',2,1,blackGen,block);  
};

// -----------------------------------------------------------------------------------
Blockly.JavaScript['put2D_1x2_BLACK'] = function(block) {
    return generatePutCode('put2D_1x2_BLACK',1,2,blackGen,block);  
};

// -----------------------------------------------------------------------------------
Blockly.JavaScript['put2D_2x2_BLACK'] = function(block) {
    return generatePutCode('put2D_2x2_BLACK',2,2,blackGen,block);  
};

// -----------------------------------------------------------------------------------
Blockly.JavaScript['put2D_3x2_BLACK'] = function(block) {
    return generatePutCode('put2D_3x2_BLACK',3,2,blackGen,block);  
};

// -----------------------------------------------------------------------------------
Blockly.JavaScript['put2D_2x3_BLACK'] = function(block) {
    return generatePutCode('put2D_2x3_BLACK',2,3,blackGen,block);  
};

// -----------------------------------------------------------------------------------
Blockly.JavaScript['put2D_4x2_BLACK'] = function(block) {
    return generatePutCode('put2D_4x2_BLACK',4,2,blackGen,block);  
};

// -----------------------------------------------------------------------------------
Blockly.JavaScript['put2D_2x4_BLACK'] = function(block) {
    return generatePutCode('put2D_2x4_BLACK',2,4,blackGen,block);  
};

// ***********************************************************************************
// ----------------------------------- GRAY -----------------------------------------
// ***********************************************************************************
Blockly.JavaScript['put2D_1x1_GRAY'] = function(block) {
    return generatePutCode('put2D_1x1_GRAY',1,1,grayGen,block);  
};

// -----------------------------------------------------------------------------------
Blockly.JavaScript['put2D_2x1_GRAY'] = function(block) {
    return generatePutCode('put2D_2x1_GRAY',2,1,grayGen,block);  
};

// -----------------------------------------------------------------------------------
Blockly.JavaScript['put2D_1x2_GRAY'] = function(block) {
    return generatePutCode('put2D_1x2_GRAY',1,2,grayGen,block);  
};

// -----------------------------------------------------------------------------------
Blockly.JavaScript['put2D_2x2_GRAY'] = function(block) {
    return generatePutCode('put2D_2x2_GRAY',2,2,grayGen,block);  
};

// -----------------------------------------------------------------------------------
Blockly.JavaScript['put2D_3x2_GRAY'] = function(block) {
    return generatePutCode('put2D_3x2_GRAY',3,2,grayGen,block);  
};

// -----------------------------------------------------------------------------------
Blockly.JavaScript['put2D_2x3_GRAY'] = function(block) {
    return generatePutCode('put2D_2x3_GRAY',2,3,grayGen,block);  
};

// -----------------------------------------------------------------------------------
Blockly.JavaScript['put2D_4x2_GRAY'] = function(block) {
    return generatePutCode('put2D_4x2_GRAY',4,2,grayGen,block);  
};

// -----------------------------------------------------------------------------------
Blockly.JavaScript['put2D_2x4_GRAY'] = function(block) {
    return generatePutCode('put2D_2x4_GRAY',2,4,grayGen,block);  
};

// ***********************************************************************************
// ----------------------------------- WHITE -----------------------------------------
// ***********************************************************************************
Blockly.JavaScript['put2D_1x1_WHITE'] = function(block) {
    return generatePutCode('put2D_1x1_WHITE',1,1,whiteGen,block);  
};

// -----------------------------------------------------------------------------------
Blockly.JavaScript['put2D_2x1_WHITE'] = function(block) {
    return generatePutCode('put2D_2x1_WHITE',2,1,whiteGen,block);  
};

// -----------------------------------------------------------------------------------
Blockly.JavaScript['put2D_1x2_WHITE'] = function(block) {
    return generatePutCode('put2D_1x2_WHITE',1,2,whiteGen,block);  
};

// -----------------------------------------------------------------------------------
Blockly.JavaScript['put2D_2x2_WHITE'] = function(block) {
    return generatePutCode('put2D_2x2_WHITE',2,2,whiteGen,block);  
};

// -----------------------------------------------------------------------------------
Blockly.JavaScript['put2D_3x2_WHITE'] = function(block) {
    return generatePutCode('put2D_3x2_WHITE',3,2,whiteGen,block);  
};

// -----------------------------------------------------------------------------------
Blockly.JavaScript['put2D_2x3_WHITE'] = function(block) {
    return generatePutCode('put2D_2x3_WHITE',2,3,whiteGen,block);  
};

// -----------------------------------------------------------------------------------
Blockly.JavaScript['put2D_4x2_WHITE'] = function(block) {
    return generatePutCode('put2D_4x2_WHITE',4,2,whiteGen,block);  
};

// -----------------------------------------------------------------------------------
Blockly.JavaScript['put2D_2x4_WHITE'] = function(block) {
    return generatePutCode('put2D_2x4_WHITE',2,4,whiteGen,block);  
};

