
//Blockly uses a Hue-Saturation-Value (HSV) colour model.
//http://www.rapidtables.com/web/color/color-picker.html  -- this doesn't work

var openColor      = 250;
var buildColor     = 250;
var callColor      = 60;
var symbolColor    = 0;
var showColor      = 250;
var offsetColor    = 190;
var declareColor   = 120;
var commentColor   = 320;

var putEmptyColor  = callColor;
var putYellowColor = callColor;
var putBlueColor   = callColor;
var putRedColor    = callColor;
var putGreenColor  = callColor;
var putGrayColor   = callColor;
var putBlackColor  = callColor;
var putWhiteColor  = callColor;

var imageWidth  = "25";
var imageHeight = "25";

var xml_text     = "";
var reified_xml  = "";

// ===================================================================================
// ----------------------------------- Show XML --------------------------------------
// ===================================================================================
function showCodeAsXML() {
    var xml      = Blockly.Xml.workspaceToDom(workspace);
    var xml_text = Blockly.Xml.domToPrettyText(xml);

    var win = window.open("about:blank", null, "width=600,height=600");
    
    var doc = win.document;
    
    doc.open("text/plain");
                                        
    doc.write('<xmp>' + xml_text + '</xmp>');
    
    doc.close();                      
}

// ===================================================================================
function saveXML() {
    var xml      = Blockly.Xml.workspaceToDom(workspace);
    var xml_text = Blockly.Xml.domToPrettyText(xml);
    var filename = document.getElementById("xmlfilename").value;

    var pom = document.createElement('a');
    pom.setAttribute('href', 'data:text/plain;charset=utf-8,' + encodeURIComponent(xml_text));
    pom.setAttribute('download', filename);

    pom.style.display = 'none';
    document.body.appendChild(pom);

    pom.click();

    document.body.removeChild(pom);

}

// ===================================================================================
function download() {
    
    var filename = document.getElementById("filename").value;
    var text = document.getElementById("bricklayerCode").value;
    
    var pom = document.createElement('a');
    pom.setAttribute('href', 'data:text/plain;charset=utf-8,' + encodeURIComponent(text));
    pom.setAttribute('download', filename);

    pom.style.display = 'none';
    document.body.appendChild(pom);

    pom.click();

    document.body.removeChild(pom);
}

// ===================================================================================
function init() {
		var fileInput = document.getElementById('fileInput');
		//var fileDisplayArea = document.getElementById('fileDisplayArea');
        // e.g. <pre id="fileDisplayArea">text here<pre>

		fileInput.addEventListener('change', function(e) {
			var file = fileInput.files[0];
			var textType = /text.*/;

			if (file.type.match(textType)) {
				var reader = new FileReader();

				reader.onload = function(e) {
                xml_text = reader.result;                    
 
				//fileDisplayArea.innerText = xml_text;

                reified_xml = Blockly.Xml.textToDom(xml_text);
                Blockly.Xml.domToWorkspace(workspace, reified_xml);                    
				}

				reader.readAsText(file);	
			} else {
				fileDisplayArea.innerText = "File not supported!";
			}
		});
}
    


// ===================================================================================
// ----------------------------------- Build -----------------------------------------
// ===================================================================================

Blockly.Blocks['bbuild'] = {
  /**
   * Block for print statement.
   * @this Blockly.Block
   */
  init: function() {      
    this.jsonInit({
      "message0": '%1 build2D %2 %3',
      "args0": [
        {
           "type"   : "field_image",
           "src"    : "images/bricklayer_lite_images/grid.jpg",
           "width"  : imageWidth,
           "height" : imageHeight,
           "alt"    : "*"
        }
        ,        
        {
          "type": "field_dropdown",
          "name": "size",
          "options": [ ["(2,2)","(2,2)"], ["(4,4)","(4,4)"], ["(8,8)","(8,8)"], ["(16,16)","(16,16)"], ["(32,32)","(32,32)"], ["(64,64)","(64,64)"], ["(128,128)","(128,128)"] ]
        }
        ,
        {
          "type": "input_value",
          "name": "semi_or_epsilon",
          "check": "semicolon"
        }
        
      ],
      "previousStatement": [ "bopen" ],
      "nextStatement": null,
      "colour": buildColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};

// ===================================================================================
// ----------------------------------- Show ------------------------------------------
// ===================================================================================

Blockly.Blocks['show'] = {
  /**
   * Block for print statement.
   * @this Blockly.Block
   */
  init: function() {      
    this.jsonInit({
      "message0": '%1 show2D %2 %3',
      "args0": [
        {
           "type"   : "field_image",
           "src"    : "images/bricklayer_lite_images/Fotolia_eye.jpg",
           "width"  : imageWidth,
           "height" : imageHeight,
           "alt"    : "*"
        }
        ,        
        {
          "type": "field_input",
          "name": "artifact",
          "text": "\"thing\""
        }
        ,
        {
          "type": "input_value",
          "name": "semi_or_epsilon",
          "check": "semicolon"
        }
        
      ],
      "previousStatement": null,
      //"nextStatement": null,
      "colour": showColor,
      "tooltip": Blockly.Msg.TEXT_PRINT_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_PRINT_HELPURL
    }); 
  }
};



