'use strict';

goog.provide('Blockly.JavaScript.texts');
goog.require('Blockly.JavaScript');


// ***********************************************************************************
// ----------------------------------- auxiliary -------------------------------------
// ***********************************************************************************

/*
function generatePutCode(name, xSize, zSize, brick, block) {
    
    var x    = block.getFieldValue('xVal');
    var z    = block.getFieldValue('zVal');
    var sym  = Blockly.JavaScript.valueToCode(block, 'semi_or_epsilon', Blockly.JavaScript.ORDER_ADDITION) || '1';     
    var code = 'put(' + xSize + ',' + zSize + ',' + x + ',' + z + ',' + brick + ');\n';    

    processBegin('call', name + '(' + x + ',' + z + ')',sym);         
    processEnd  (CALL  , name + '(' + x + ',' + z + ')' + sym);
    
    return code;    
}

*/

// ***********************************************************************************
// ----------------------------------- lineXZ ----------------------------------------
// ***********************************************************************************
Blockly.JavaScript['lineXZ'] = function(block) {
    
    var name   = 'lineXZ';
    var x1     = block.getFieldValue('x1');
    var z1     = block.getFieldValue('z1');
    var x2     = block.getFieldValue('x2');
    var z2     = block.getFieldValue('z2');
	
    var brick  = block.getFieldValue('brick');    
	
    var sym    = Blockly.JavaScript.valueToCode(block, 'semi_or_epsilon', Blockly.JavaScript.ORDER_ADDITION) || '1';     
    var code   = 'lineXZ(' + x1 + ',' + z1 + ',' + x2 + ',' + z2 + ',' + '\'' + brick + '\'' + ');\n';    
	
    var brickId = colorToBrick(brick);
    
	var stateMachineCode = name + ' (' + x1 + ',' + z1 + ')' + ' (' + x2 + ',' + z2 + ') ' + brickId ;
    
    processBegin('lineXZ', stateMachineCode , sym);         
    processEnd  (CALL    , stateMachineCode + sym);
       
    wellFormedInt(x1);
    wellFormedInt(z1);
  
    wellFormedInt(x2);
    wellFormedInt(z2);
       
    return code;    
}


