
// =======================================================================================
function auxLine (p1, p2, brick) {
	// from (x1,z1) to (x2,z2)
	//
	// p1 - p2 = (x1-x2,y1-y2,z1-z2)
    //                     
    // (x,y,z) = p1 + t(x1-x2,y1-y2,z1-z2) 
    //         = (x1 + (x1-x2)t, y1 + (y1-y2)t, z1 + (z1-z2)t)

	
	function alongSingleAxis(p1,p2) {
		return p1[0] == p2[0] || p2[1] == p2[1];
	}
	
	var deltaX = p2[0] - p1[0];
	var deltaZ = p2[1] - p1[1];	
	
	var step        = Math.max( Math.abs(deltaX), Math.abs(deltaZ) );
	var granularity = alongSingleAxis(p1,p2) ? 0 : 4000; // smooth out lines and fix round-off errors

    var deltaT = 1 / (step + granularity);
    //alert('deltaT = ' + deltaT);

	function eq(v1,v2) {
		var epsilon = 0.1;

		// alert('Math.abs(v1 - v2) < epsilon = ' + (Math.abs(v1 - v2) < epsilon));			
		return Math.abs(v1 - v2) < epsilon;
	}
	
	function eqPoint(p1,p2) {
		var result = true;
		var i;
		
		for (i = 0; i < 2; i++) {
			result = result && eq(p1[i],p2[i]);
		}
		
		return result;		
	}

	var x1 = p1[0];
	var z1 = p1[1];

	function pointAtT( t ) {
		return [ x1 + t*deltaX, z1 + t*deltaZ ];
	}

	function update(p,brick) { 
		auxPut(Math.round(p[0]),Math.round(p[1]),brick);
	}

	var currentT = 0.0;
	var currentP = pointAtT(currentT);

	while (!(eqPoint(currentP,p2))) {		
		update(currentP,brick);
		currentT = currentT + deltaT;	
		currentP = pointAtT(currentT);		
	}
	
	update(currentP,brick);
	
}

// =======================================================================================
function line ( p1 , p2, brick) {
	
	function posShift( p ) {
		return [ p[0] + xOffset, p[1] + zOffset];
	}
	
	var shiftedP1 = posShift(p1);	
	var shiftedP2 = posShift(p2);

	auxLine( shiftedP1, shiftedP2, brick);
}

function lineXZ (x1,z1,x2,z2,brick) {
	line ([x1,z1], [x2,z2], brick);
}
// =======================================================================================

