'use strict';

goog.provide('Blockly.JavaScript.texts');
goog.require('Blockly.JavaScript');


// ***********************************************************************************
// ----------------------------------- auxiliary -------------------------------------
// ***********************************************************************************

/*
function generatePutCode(name, xSize, zSize, brick, block) {
    
    var x    = block.getFieldValue('xVal');
    var z    = block.getFieldValue('zVal');
    var sym  = Blockly.JavaScript.valueToCode(block, 'semi_or_epsilon', Blockly.JavaScript.ORDER_ADDITION) || '1';     
    var code = 'put(' + xSize + ',' + zSize + ',' + x + ',' + z + ',' + brick + ');\n';    

    processBegin('call', name + '(' + x + ',' + z + ')',sym);         
    processEnd  (CALL  , name + '(' + x + ',' + z + ')' + sym);
    
    
    return code;    
}
*/

// ***********************************************************************************
// ----------------------------------- put2D -----------------------------------------
// ***********************************************************************************
Blockly.JavaScript['put2D'] = function(block) {
    
    var name   = 'put2D';
    var xSize  = block.getFieldValue('xSize');
    var zSize  = block.getFieldValue('zSize');
    var brick  = block.getFieldValue('brick');    
    var x      = block.getFieldValue('xArg');
    var z      = block.getFieldValue('zArg');
    var sym    = Blockly.JavaScript.valueToCode(block, 'semi_or_epsilon', Blockly.JavaScript.ORDER_ADDITION) || '1';     
    var code   = 'put(' + xSize + ',' + zSize + ',' + x + ',' + z + ',' + '\'' + brick + '\'' + ');\n';    

    var brickId = colorToBrick(brick);
    
    processBegin('put2D', name + ' (' + xSize + ',' + zSize + ') ' + brickId  + ' (' + x + ',' + z + ')',sym);         
    processEnd  (CALL  , name + ' (' + xSize + ',' + zSize + ') ' + brickId  + ' (' + x + ',' + z + ')' + sym);
       
    wellFormedInt(xSize);
    wellFormedInt(zSize);
  
    wellFormedInt(x);
    wellFormedInt(z);
       
    return code;    
}


