
var kBoardWidth;
var kBoardHeight;

var kStep;
var side;

var kPixelWidth;
var kPixelHeight;

var yEnd;
var xEnd;


var gCanvasElement;
var gDrawingContext;

var red        = "#B40404";
var green      = "#04B404";
var blue       = "#2E64FE";
var yellow     = "#D7DF01";
var white      = "#F2F2F2";
var black      = "#000000";
var blueviolet = "#8A2BE2";

var palletSize = 0;

var fillColor = white;
var lineColor = "black";

var bleep = new Audio();
bleep.src = 'click_real_short.mp3';


var timestep           = 100;
var stampColor         = blue;
var canvasColor        = white;
var lineColor          = white;
var customCanvasCalled = false;


// =======================================================================================
// =======================================================================================
function Cell(row, column) {
    this.row = row;
    this.column = column;
}

// =======================================================================================
function getCursorPosition(e) {
    /* returns Cell with .row and .column properties */
    var x;
    var y;
    if (e.pageX != undefined && e.pageY != undefined) {
        x = e.pageX;
        y = e.pageY;
    }
    else {
        x = e.clientX + document.body.scrollLeft + document.documentElement.scrollLeft;
        y = e.clientY + document.body.scrollTop + document.documentElement.scrollTop;
    }
    x -= gCanvasElement.offsetLeft;
    y -= gCanvasElement.offsetTop;
    x = Math.min(x, kBoardWidth * kStep);
    y = Math.min(y, kBoardHeight * kStep);
    var cell = new Cell(Math.floor(y/kStep), Math.floor(x/kStep));
    return cell;
}

// =======================================================================================
function getCursorPalletPosition(e) {
    /* returns Cell with .row and .column properties */
    var x;
    var y;
    if (e.pageX != undefined && e.pageY != undefined) {
        x = e.pageX;
        y = e.pageY;
    }
    else {
        x = e.clientX + document.body.scrollLeft + document.documentElement.scrollLeft;
        y = e.clientY + document.body.scrollTop + document.documentElement.scrollTop;
    }
    x -= gCanvasElement.offsetLeft;
    y -= gCanvasElement.offsetTop;
    x = Math.min(x, kBoardWidth * kStep);
    y = Math.min(y, kBoardHeight * kStep);
    var cell = new Cell(y,x);
    return cell;
}

// =======================================================================================
function vitruviaOnClick(e) {
    var cell   = getCursorPalletPosition(e);
    var row    = cell.row;
    var column = cell.column;

    bleep.play();
    
   drawCell(row,column);   
}

// =======================================================================================
function drawCell(column,row,fillColor)
{
   var x = column * kStep;
   var y = (yEnd - kStep) - row * kStep;
   
  
   //alert('drawing cell (x,y) = (' + x + ',' + y + ')');
   
   gDrawingContext.fillStyle = fillColor;
   
   if (lineColor != canvasColor) {
        gDrawingContext.fillRect(x+1, y, kStep-1, kStep-1); // box lines don't get redrawn with empty color
   }
   else {
       gDrawingContext.fillRect(x, y, kStep, kStep); // box lines don't get redrawn with empty color
   }
   
    
}

// =======================================================================================

function thunk () { setTimeout( function f() {}, timestep); }

function lace01(n,x,y,fillColor, continuation) {
    if (halt) throw "halt"; 
    else if (n === 0) { drawCell(x,y,fillColor); continuation()}
    else {
            var next   = n-1;
            var delta  = Math.pow(2,next); 

            var continuation2 = function () {
                                              setTimeout( function f2() {lace01(next, x+delta,y+delta,fillColor,continuation);},
                                                          timestep
                                                         );
                                            }                                                                      

            var continuation1 =  function () {
                                               setTimeout( function f1 () {lace01(next, x+delta,y,fillColor, continuation2);},
                                                           timestep
                                                         );                                                
                                             };      
            
            lace01(next, x,y, fillColor, continuation1);
    };
}

// ---------------------------------------------------------------------------------------
function lace01Stamp(n,x,y,fillColor,continuation) {
    if (n === 0) { drawCell(x,y,fillColor); continuation(); }
    else {
            var next   = n-1;
            var delta  = Math.pow(2,next); 
            
            lace01Stamp(next, x      ,y      , fillColor,thunk);
            lace01Stamp(next, x+delta,y      , fillColor,thunk);
            lace01Stamp(next, x+delta,y+delta, fillColor, continuation);           
    };
}    
    
// =======================================================================================
function lace02(n,x,y,fillColor, continuation) {
    if (halt) throw "halt"; 
    else if (n === 0) { drawCell(x,y,fillColor); continuation()}
    else {
            var next   = n-1;
            var delta  = Math.pow(3,next); 

            var continuation4 = function () {
                                              setTimeout( function f4() {lace02(next, x+delta,y+delta,fillColor,continuation);},
                                                          timestep
                                                         );
                                            }                                                                      
            
            var continuation3 = function () {
                                              setTimeout( function f3() {lace02(next, x-delta,y+delta,fillColor,continuation4);},
                                                          timestep
                                                         );
                                            }                                                                      
            
            var continuation2 = function () {
                                              setTimeout( function f2() {lace02(next, x,y+2*delta,fillColor,continuation3);},
                                                          timestep
                                                         );
                                            }                                                                      

            var continuation1 =  function () {
                                               setTimeout( function f1 () {lace02(next, x,y+delta,fillColor, continuation2);},
                                                           timestep
                                                         );                                                
                                             };      
            
            lace02(next, x,y, fillColor, continuation1);
            
    };
}

// ---------------------------------------------------------------------------------------
function lace02Stamp(n,x,y,fillColor,continuation) {
    if (n === 0) { drawCell(x,y,fillColor); continuation(); }
    else {
            var next   = n-1;
            var delta  = Math.pow(3,next); 
            
            lace02Stamp(next, x      ,y        , fillColor,thunk);
            lace02Stamp(next, x      ,y+delta  , fillColor,thunk);
            lace02Stamp(next, x-delta,y+delta  , fillColor,thunk);            
            lace02Stamp(next, x+delta,y+delta  , fillColor,thunk);                        
            lace02Stamp(next, x      ,y+2*delta, fillColor, continuation);           
    };
}    

// =======================================================================================
function lace03(n,x,y,fillColor, continuation) {
    if (halt) throw "halt"; 
    else if (n === 0) { drawCell(x,y,fillColor); continuation()}
    else {
            var next   = n-1;
            var delta  = Math.pow(3,next); 

            var lace = lace03;
            
            var continuation5 = function () {
                                              setTimeout( function f4() {lace(next, x+2*delta,y,fillColor,continuation);},
                                                          timestep
                                                         );
                                            }                                                                      
            
            var continuation4 = function () {
                                              setTimeout( function f4() {lace(next, x+2*delta,y+delta,fillColor,continuation5);},
                                                          timestep
                                                         );
                                            }                                                                      
            
            var continuation3 = function () {
                                              setTimeout( function f3() {lace(next, x+delta,y+delta,fillColor,continuation4);},
                                                          timestep
                                                         );
                                            }                                                                      
            
            var continuation2 = function () {
                                              setTimeout( function f2() {lace(next, x,y+2*delta,fillColor,continuation3);},
                                                          timestep
                                                         );
                                            }                                                                      

            var continuation1 =  function () {
                                               setTimeout( function f1 () {lace(next, x,y+delta,fillColor, continuation2);},
                                                           timestep
                                                         );                                                
                                             };      
            
            lace(next, x,y, fillColor, continuation1);
            
    };
}

// ---------------------------------------------------------------------------------------
function lace03Stamp(n,x,y,fillColor,continuation) {
    if (n === 0) { drawCell(x,y,fillColor); continuation(); }
    else {
            var next   = n-1;
            var delta  = Math.pow(3,next); 
            
            lace03Stamp(next, x        ,y        , fillColor,thunk);
            lace03Stamp(next, x        ,y+delta  , fillColor,thunk);
            lace03Stamp(next, x        ,y+2*delta, fillColor,thunk);           
            lace03Stamp(next, x+delta  ,y+delta  , fillColor,thunk);            
            lace03Stamp(next, x+2*delta,y+delta  , fillColor,thunk);            
            lace03Stamp(next, x+2*delta,y        , fillColor,continuation);            
    };
}    

// =======================================================================================
function lace04(n,x,y,fillColor, continuation) {
    if (halt) throw "halt"; 
    else if (n === 0) { drawCell(x,y,fillColor); continuation()}
    else {
            var next   = n-1;
            var delta  = Math.pow(3,next); 

            var lace = lace04;

            var continuation7 = function () {
                                              setTimeout( function f() {lace(next, x,y+delta,fillColor,continuation);},
                                                          timestep
                                                         );
                                            }                                                                      
            
            var continuation6 = function () {
                                              setTimeout( function f() {lace(next, x,y+2*delta,fillColor,continuation7);},
                                                          timestep
                                                         );
                                            }                                                                      
            
            var continuation5 = function () {
                                              setTimeout( function f() {lace(next, x+delta,y+2*delta,fillColor,continuation6);},
                                                          timestep
                                                         );
                                            }                                                                      
            
            var continuation4 = function () {
                                              setTimeout( function f() {lace(next, x+2*delta,y+2*delta,fillColor,continuation5);},
                                                          timestep
                                                         );
                                            }                                                                      
            
            var continuation3 = function () {
                                              setTimeout( function f() {lace(next, x+2*delta,y+delta,fillColor,continuation4);},
                                                          timestep
                                                         );
                                            }                                                                      
            
            var continuation2 = function () {
                                              setTimeout( function f() {lace(next, x+2*delta,y,fillColor,continuation3);},
                                                          timestep
                                                         );
                                            }                                                                      

            var continuation1 = function () {
                                              setTimeout( function f() {lace(next, x+delta,y,fillColor, continuation2);},
                                                          timestep
                                                        );                                                
                                             };      
            
            lace(next, x,y, fillColor, continuation1);
            
    };
}

// ---------------------------------------------------------------------------------------
function lace04Stamp(n,x,y,fillColor,continuation) {
    if (n === 0) { drawCell(x,y,fillColor); continuation(); }
    else {
            var next   = n-1;
            var delta  = Math.pow(3,next); 
            
            lace04Stamp(next, x        ,y        , fillColor,thunk);
            lace04Stamp(next, x+delta  ,y        , fillColor,thunk);
            lace04Stamp(next, x+2*delta,y        , fillColor,thunk);           
            lace04Stamp(next, x+2*delta,y+1*delta, fillColor,thunk);                        
            lace04Stamp(next, x+2*delta,y+2*delta, fillColor,thunk);            
            lace04Stamp(next, x+delta  ,y+2*delta, fillColor,thunk);            
            lace04Stamp(next, x        ,y+2*delta, fillColor,thunk);            
            lace04Stamp(next, x        ,y+delta  , fillColor,continuation);            
    };
}    

// =======================================================================================
function lace05(n,x,y,fillColor, continuation) {
    
    if (halt) throw "halt"    
    else if (n === 0) { drawCell(x,y,fillColor); continuation()}
    else {
            var next   = n-1;
            var delta  = Math.pow(3,next); 

            var lace = lace05;
                        
            var continuation4 = function () {
                                              setTimeout( function f() {lace(next, x+2*delta,y,fillColor,continuation);},
                                                          timestep
                                                         );
                                            }                                                                      
            
            var continuation3 = function () {
                                              setTimeout( function f() {lace(next, x,y+2*delta,fillColor,continuation4);},
                                                          timestep
                                                         );
                                            }                                                                      
            
            var continuation2 = function () {
                                              setTimeout( function f() {lace(next, x+2*delta,y+2*delta,fillColor,continuation3);},
                                                          timestep
                                                         );
                                            }                                                                      

            var continuation1 =  function () {
                                               setTimeout( function f () {lace(next, x+delta,y+delta,fillColor, continuation2);},
                                                           timestep
                                                         );                                                
                                             };      
            
            lace(next, x,y, fillColor, continuation1);
            
    };
}

// ---------------------------------------------------------------------------------------
function lace05Stamp(n,x,y,fillColor,continuation) {
    if (n === 0) { drawCell(x,y,fillColor); continuation(); }
    else {
            var next   = n-1;
            var delta  = Math.pow(3,next); 
            
            lace05Stamp(next, x        ,y         , fillColor,thunk);
            lace05Stamp(next, x+delta  ,y+delta   , fillColor,thunk);
            lace05Stamp(next, x+2*delta,y+2*delta , fillColor,thunk);            
            lace05Stamp(next, x        ,y+2*delta , fillColor,thunk);                        
            lace05Stamp(next, x+2*delta,y         , fillColor, continuation);           
    };
}    

// =======================================================================================
var step1  = 0;
var stamp1 = 0;

var step2  = 0;
var stamp2 = 0;

var step3  = 0;
var stamp3 = 0;


var step4  = 0;
var stamp4 = 0;

var step5  = 0;
var stamp5 = 0;


const LACE1 = 1;
const LACE2 = 2;
const LACE3 = 3;
const LACE4 = 4;
const LACE5 = 5;

var selectedLace = LACE1; // default

var halt = false;

function selectLace(laceId) {
    var selectedImage = document.getElementById("selected-image");
    
    switch (laceId) {
        case 1:  selectedLace = LACE1;
                 selectedImage.setAttribute("src","images/lace_01.png");
                 step1  = 0;
                 stamp1 = 0;                
                 initGame(32);
                 break;
        case 2:  selectedLace = LACE2;
                 selectedImage.setAttribute("src","images/lace_02.png");
                 initGame(27);
                 step2  = 0;
                 stamp2 = 0;                                
                 break;
        case 3:  selectedLace = LACE3;
                 selectedImage.setAttribute("src","images/lace_03.png");        
                 initGame(27);
                 step3  = 0;
                 stamp3 = 0;                                                 
                 break;
        case 4:  selectedLace = LACE4;
                 selectedImage.setAttribute("src","images/lace_04.png");        
                 initGame(27);
                 step4  = 0;
                 stamp4 = 0;                                                                  
                 break;
        case 5:  selectedLace = LACE5;
                 selectedImage.setAttribute("src","images/lace_05.png");        
                 initGame(27);
                 step5  = 0;
                 stamp5 = 0;                                                                                   
                 break;
        default: selectedLace = LACE1;
                 selectedImage.setAttribute("src","images/lace_01.png");        
                 break;                        
    }    
}


function stampFunction() {
    switch (selectedLace) {
        case LACE1: stampFunction01();
                    break;
        case LACE2: stampFunction02();
                    break;
        case LACE3: stampFunction03();
                    break;
        case LACE4: stampFunction04();
                    break;
        case LACE5: stampFunction05();
                    break;
                    
        default: break;
    }
}

function stepFunction() {
    try {
            switch (selectedLace) {
                case LACE1: stepFunction01();
                            break;
                case LACE2: stepFunction02();
                            break;
                case LACE3: stepFunction03();
                            break;
                case LACE4: stepFunction04();
                            break;
                case LACE5: stepFunction05();
                            break;
                            
                default: break;
            }
    }
    catch (err) {
        alert('catch');
        selectLace(selectedLace);
    }
}

function haltAnimation() {
    halt = true;
}

function clearGrid() {
        selectLace(selectedLace);       
}
// =======================================================================================
function stepFunction01() {
    step1 = 5;
    if (step1 < 6) { initGame(32); lace01(step1++,0,0,stampColor,thunk); }
    else { step1=0; initGame(32);}
}

// ---------------------------------------------------------------------------------------
function stampFunction01() {
   
    if (stamp1 == 0 || step1 > 0) {
        stamp1 = 0;
        step1  = 0;
        
        initGame(32);
        lace01Stamp(0,0,0,stampColor,thunk);
        stamp1++
    }
    
    else if (stamp1 > 5) {
        initGame(32);
        stamp1 = 0;
    }
    
    else {
        
        var previous = stamp1 - 1;
        var delta  = Math.pow(2,previous);
        
        
        var continuation1 =  function () {
                                   setTimeout( function f () {lace01Stamp(previous,delta,delta, stampColor,thunk);},
                                               3*timestep
                                             );                                                
                                 };  
                                 
        lace01Stamp(previous,delta,0, stampColor,continuation1);
        
        stamp1++;
    }
}

// =======================================================================================
function stepFunction02() {
    step2 = 3;
    
    if (step2 < 4) { initGame(27); lace02(step2++,13,0,stampColor,thunk); }
    else { step2=0; initGame(32);}
}

// ---------------------------------------------------------------------------------------
function stampFunction02() {
   
    var startX = 13;
    
    if (stamp2 == 0 || step2 > 0) {
        stamp2 = 0;
        step2  = 0;
        
        initGame(27);
        lace02Stamp(0,startX,0,stampColor,thunk);
        stamp2++
    }
    
    else if (stamp2 > 3) {
        initGame(27);
        stamp2 = 0;
    }
    
    else {
        
        var previous = stamp2 - 1;
        var delta    = Math.pow(3,previous);
                                                 
        var continuation3 =  function () {
                                           setTimeout( function f () {lace02Stamp(previous,startX+delta,delta, stampColor,thunk);},
                                                       3*timestep
                                                     );                                                
                                         };  
                                 
        var continuation2 =  function () {
                                           setTimeout( function f () {lace02Stamp(previous,startX-delta,delta, stampColor,continuation3);},
                                                       3*timestep
                                                     );                                                
                                         };  


        var continuation1 =  function () {
                                           setTimeout( function f () {lace02Stamp(previous,startX,2*delta, stampColor,continuation2);},
                                                       3*timestep
                                                     );                                                
                                         };  
                                         
        lace02Stamp(previous,startX,delta, stampColor,continuation1);
        
        stamp2++;
    }
}

// =======================================================================================
function stepFunction03() {
    step3 = 3;
  
    if (step3 < 4) { initGame(27); lace03(step3++,0,0,stampColor,thunk); }
    else { step3=0; initGame(32);}
}

// ---------------------------------------------------------------------------------------
function stampFunction03() {
   
    var startX = 0;
    var startY = 0;
    
    if (stamp3 == 0 || step3 > 0) {
        stamp3 = 0;
        step3  = 0;
        
        initGame(27);
        lace03Stamp(0,startX,startY,stampColor,thunk);
        stamp3++
    }
    
    else if (stamp3 > 3) {
        initGame(27);
        stamp3 = 0;
    }
    
    else {
        
        var previous = stamp3 - 1;
        var delta    = Math.pow(3,previous);

        var continuation4 =  function () {
                                           setTimeout( function f () {lace03Stamp(previous,startX+2*delta,startY, stampColor,thunk);},
                                                       3*timestep
                                                     );                                                
                                         };  
        
        var continuation3 =  function () {
                                           setTimeout( function f () {lace03Stamp(previous,startX+2*delta,startY+delta, stampColor,continuation4);},
                                                       3*timestep
                                                     );                                                
                                         };  
                                 
        var continuation2 =  function () {
                                           setTimeout( function f () {lace03Stamp(previous,startX+delta,startY+delta, stampColor,continuation3);},
                                                       3*timestep
                                                     );                                                
                                         };  


        var continuation1 =  function () {
                                           setTimeout( function f () {lace03Stamp(previous,startX,startY+2*delta, stampColor,continuation2);},
                                                       3*timestep
                                                     );                                                
                                         };  
                                         
        lace03Stamp(previous,startX,startY+delta, stampColor,continuation1);
        
        stamp3++;
    }
}

// =======================================================================================
function stepFunction04() {
    step4 = 3;
  
    if (step4 < 4) { initGame(27); lace04(step4++,0,0,stampColor,thunk); }
    else { step4=0; initGame(32);}
}

// ---------------------------------------------------------------------------------------
function stampFunction04() {
   
    var startX = 0;
    var startY = 0;
    
    if (stamp4 == 0 || step4 > 0) {
        stamp4 = 0;
        step4  = 0;
        
        initGame(27);
        lace04Stamp(0,startX,startY,stampColor,thunk);
        stamp4++
    }
    
    else if (stamp4 > 3) {
        initGame(27);
        stamp4 = 0;
    }
    
    else {
        
        var previous = stamp4 - 1;
        var delta    = Math.pow(3,previous);

        var continuation6 =  function () {
                                           setTimeout( function f () {lace04Stamp(previous,startX,startY+delta, stampColor,thunk);},
                                                       3*timestep
                                                     );                                                
                                         };  
        
        var continuation5 =  function () {
                                           setTimeout( function f () {lace04Stamp(previous,startX,startY+2*delta, stampColor,continuation6);},
                                                       3*timestep
                                                     );                                                
                                         };  
        
        var continuation4 =  function () {
                                           setTimeout( function f () {lace04Stamp(previous,startX+delta,startY+2*delta, stampColor,continuation5);},
                                                       3*timestep
                                                     );                                                
                                         };  

        var continuation3 =  function () {
                                           setTimeout( function f () {lace04Stamp(previous,startX+2*delta,startY+2*delta, stampColor,continuation4);},
                                                       3*timestep
                                                     );                                                
                                         };  
                                         
        var continuation2 =  function () {
                                           setTimeout( function f () {lace04Stamp(previous,startX+2*delta,startY+delta, stampColor,continuation3);},
                                                       3*timestep
                                                     );                                                
                                         };  
                                 
        var continuation1 =  function () {
                                           setTimeout( function f () {lace04Stamp(previous,startX+2*delta,startY, stampColor,continuation2);},
                                                       3*timestep
                                                     );                                                
                                         };  

                                         
        lace04Stamp(previous,startX+delta,startY, stampColor,continuation1);
        
        stamp4++;
    }
}

// =======================================================================================
function stepFunction05() {
    step5 = 3;
  
    if (step5 < 4) { initGame(27); lace05(step5++,0,0,stampColor,thunk); }
    else { step5=0; initGame(32);}
}

// ---------------------------------------------------------------------------------------
function stampFunction05() {
   
    var startX = 0;
    var startY = 0;
    
    if (stamp5 == 0 || step5 > 0) {
        stamp5 = 0;
        step5  = 0;
        
        initGame(27);
        lace05Stamp(0,startX,startY,stampColor,thunk);
        stamp5++
    }
    
    else if (stamp5 > 3) {
        initGame(27);
        stamp5 = 0;
    }
    
    else {
        
        var previous = stamp5 - 1;
        var delta    = Math.pow(3,previous);
                                                 
        var continuation3 =  function () {
                                           setTimeout( function f () {lace05Stamp(previous,startX+2*delta,startY, stampColor,thunk);},
                                                       3*timestep
                                                     );                                                
                                         };  
                                 
        var continuation2 =  function () {
                                           setTimeout( function f () {lace05Stamp(previous,startX,startY+2*delta, stampColor,continuation3);},
                                                       3*timestep
                                                     );                                                
                                         };  


        var continuation1 =  function () {
                                           setTimeout( function f () {lace05Stamp(previous,startX+2*delta,startY+2*delta, stampColor,continuation2);},
                                                       3*timestep
                                                     );                                                
                                         };  
                                         
        lace05Stamp(previous,startX+delta,startY+delta, stampColor,continuation1);
        
        stamp5++;
    }
}

// =======================================================================================
function drawLines() {
    
    lineColor = document.getElementById('lineColor').value;
    
    /* vertical lines */
    for (var x = 0; x <= xEnd; x += kStep) { 
        gDrawingContext.moveTo(0.5 + x, 0);
        gDrawingContext.lineTo(0.5 + x, yEnd);
    }
    
    /* horizontal lines */
    for (var y = 0; y <= yEnd; y += kStep) {
        gDrawingContext.moveTo(0    , 0.5 + y);
        gDrawingContext.lineTo(xEnd, 0.5 +  y);
    }
    
    /* draw it! */
    // gDrawingContext.strokeStyle = "#ccc";
    gDrawingContext.strokeStyle = lineColor;
    gDrawingContext.stroke();        
    
    gDrawingContext.closePath();

}

function drawBoard() {

   
    gDrawingContext.clearRect(0, 0, xEnd, yEnd);
     
    gDrawingContext.beginPath();

    // Canvas base color
    gDrawingContext.fillStyle = canvasColor;    
    gDrawingContext.rect(0, 0, xEnd, yEnd);
    gDrawingContext.fill();

    drawLines();
}

// =======================================================================================
// =======================================================================================
function initBoard(v) {

    var canvasElement  = document.getElementById("vitruvia_canvas"); 
    var side           = v // squares per side
    
    var boardSize;
    var delta = 0.1;
    
    if (window.innerWidth < window.innerHeight)
    { 
        boardSize = window.innerWidth - delta * window.innerWidth ;
    }
    else
    { 
        boardSize = window.innerHeight - delta * window.innerHeight;
    }

  
    kStep = Math.floor(boardSize / side)            
               
    
    //size of canvas we want to use
    kPixelWidth  = kStep * side + 1;
    kPixelHeight = kStep * side + 1;
    xEnd         = kPixelWidth;
    yEnd         = kPixelHeight;

    
    kBoardWidth  = kPixelWidth;
    kBoardHeight = kPixelHeight;  
 
    gCanvasElement        = canvasElement;
    gCanvasElement.width  = kPixelWidth  + 2*kStep // the kSteps make room for the pallet
    gCanvasElement.height = kPixelHeight + 2*kStep
    //gCanvasElement.addEventListener("click", vitruviaOnClick, false);
    gDrawingContext       = gCanvasElement.getContext("2d");

    drawBoard();
}

// =======================================================================================
function setCustomState() {
            
    timestep    = document.getElementById('animationSpeed').value;
    stampColor  = document.getElementById('stampColor').value;
    canvasColor = document.getElementById('canvasColor').value;
    lineColor   = document.getElementById('lineColor').value;
    halt        = false;
       
}

function setDefaultState() {
        
    timestep    = 100;
    stampColor  = blue;
    canvasColor = white;
    lineColor   = black;
    halt        = false;
}     

// =======================================================================================
function customCanvas(v) {
    
    customCanvasCalled = true;
    setCustomState();
    initBoard(v);   
}

// =======================================================================================
function initGame(v) {
    
    if (customCanvasCalled) {
        setCustomState();
    }
    else {
        setDefaultState()
    }
    
    initBoard(v);   
}

// =======================================================================================





